<?php
/**
 * PiulaRss PHP Twitter RSS Feed with Oauth v 1.5
 * ==============================
 *
 * License: MIT-style license http://opensource.org/licenses/MIT
 * Author: Oriol Rigola (http://www.morintsol.com)
 */

require_once ("mytwit.inc.php");

//Ini Config
$piulador='XXXXXXXXXXXXXXX'; //Usuari twitter que resoldr per defecte
$TWITTER_CONSUMER_KEY='XXXXXXXXXXXXXXX'; //Clau aplicaci API TWITTER_CONSUMER_KEY
$TWITTER_CONSUMER_SECRET = 'XXXXXXXXXXXXXXX'; //Clau aplicaci API TWITTER_CONSUMER_SECRET
$TWITTER_OAUTH_ACCESS_TOKEN = 'XXXXXXXXXXXXXXX'; //Clau aplicaci API OAUTH_ACCESS_TOKEN
$TWITTER_OAUTH_ACCESS_TOKEN_SECRET = 'XXXXXXXXXXXXXXX'; //Clau aplicaci API OAUTH_ACCESS_TOKEN_SECRET
//Fi Config

//Recull parmetres de la URL
$gp_u=$_GET["u"];
if (isset($gp_u)){
 $piulador=$gp_u;
}
//Fi parmetres URL

//Funcions
function xml_entities($string) {
    return strtr(
        $string, 
        array(
            "<" => "&lt;",
            ">" => "&gt;",
            '"' => "&quot;",
            "'" => "&apos;",
            "&" => "&amp;",
        )
    );
}

function getCurrentUrl(){  
	$domain = $_SERVER['HTTP_HOST'];  
	$url = "http://" . $domain . $_SERVER['REQUEST_URI'];  
	return $url;  
}

function tagxml($text){
 echo "<?xml ".$text." ?>\n";
}

$tFeed = new MyTwit;
$tFeed->TwitterUser = $piulador;
$tFeed->TWITTER_CONSUMER_KEY = $TWITTER_CONSUMER_KEY;
$tFeed->TWITTER_CONSUMER_SECRET = $TWITTER_CONSUMER_SECRET;
$tFeed->TWITTER_OAUTH_ACCESS_TOKEN = $TWITTER_OAUTH_ACCESS_TOKEN;
$tFeed->TWITTER_OAUTH_ACCESS_TOKEN_SECRET = $TWITTER_OAUTH_ACCESS_TOKEN_SECRET;
// $tFeed->PostLimit = 5; //No provat
// $tFeed->ExcludeReplies = true; //No provat
$tFeed->UpdateCache();

if ($tFeed->ErrorMessage) {
	echo '<div class="TwitError">
		<h3>Error processant twitter feed</h3>
		<p>'.$tFeed->ErrorMessage.'</p>
	</div>';
}

header('Content-type: application/xml');
tagxml('version="1.0" encoding="ISO-8859-1"');

$ind="/index.php";
$tab="	";
$fitag="?".">";

?><rss version="2.0" xmlns:atom="http://www.w3.org/2005/Atom">
<channel>
	<title><?php echo $tFeed->TwitterUser; ?></title>
	<link><?php echo 'https://twitter.com/'.$tFeed->TwitterUser; ?></link>
	<atom:link href="<?php echo getCurrentUrl(); ?>?u=<?php echo $tFeed->TwitterUser; ?>" rel="self" type="application/rss+xml" />
	<image>
		<title><?php echo $tFeed->TwitterUser; ?></title>
		<url><?php echo $tFeed->UserInfo['user_profile_image_url_https']; ?></url>
		<link><?php echo 'https://twitter.com/'.$tFeed->TwitterUser; ?></link>
		<description><?php echo iconv('UTF-8','ISO-8859-1',xml_entities($tFeed->UserInfo['user_description'])); ?></description>
	</image>
	<description><?php echo iconv('UTF-8','ISO-8859-1',xml_entities($tFeed->UserInfo['user_description'])); ?></description>
	<lastBuildDate><?php echo date("r"); ?></lastBuildDate>
	<language>ca</language>
<?php
	foreach ($tFeed->Tweets as $tweet) { ?>
	<item>
		<title><?php echo iconv('UTF-8','ISO-8859-1',xml_entities($tweet['text'])); ?></title>
		<link><?php echo 'https://twitter.com/'.$tFeed->TwitterUser; ?></link>
		<description><![CDATA[ <div align="justify"><?php echo iconv('UTF-8','ISO-8859-1',xml_entities($tweet['text'])); ?></div> ]]></description>
		<guid isPermaLink="true"><?php echo 'https://twitter.com/'.$tFeed->TwitterUser.'/status/'.$tweet['id_str']; ?></guid>
		<pubDate><?php echo date("r",strtotime($tweet['created_at'])); ?></pubDate>
	</item>
<?php
	}
?></channel>
</rss>